AUTOBAHN_DEBUG = true;
const autobahn = require('autobahn')
const program = require('commander')

program
  .option('-s, --server <server>', 'Server URI address', 'ws://127.0.0.1:9000/wamp')
  .parse(process.argv)

console.log('connect to server:', program.server)

let user = 'joe'
let key = 'joe-secret'

// this callback is fired during authentication
function onchallenge (session, method, extra) {
  if (method === 'ticket') {
    return key
  } else {
    throw new Error("don't know how to authenticate using '" + method + "'")
  }
}

var connection = new autobahn.Connection({
  url: program.server,
  realm: 'crossbardemo',
//  authmethods: ['ticket', 'wampcra'],
//  authid: user,
//  authextra: {extra1:1},
  tlsConfiguration: {},
  onchallenge: onchallenge
})

connection.onopen = function (session) {
console.log('ENTER', 1)

  // Define an event handler
  function onEvent (publishArgs, kwargs, opts) {
    console.log('Event', opts, 'received args', publishArgs, 'kwargs ', kwargs)
  }

  // Subscribe to a topic
  session.subscribe('io.crossbar.demo.pubsub', onEvent, { match: "prefix" }).then(
    function (subscription) {
      console.log('subscription successfull', subscription.topic)
    },
    function (error) {
      console.log('subscription failed', error)
    }
  )

}

connection.onclose = function (reason, details) {
  console.log('disconnected', reason, details)
}

connection.open()

/*

ENTER 1
[ 32, 1, { match: 'prefix' }, 'io.crossbar.demo.pubsub' ]
subscription successfull io.crossbar.demo.pubsub
Event Event {
  publication: 4473342249036663,
  topic: 'io.crossbar.demo.pubsub.075590',
  publisher: 8721279315556278,
  publisher_authid: 'JQGV-P7JL-VJGT-TATK-KTVX-PRUL',
  publisher_authrole: 'anonymous',
  retained: false } received args [ 'Hello, world. 11X' ] kwargs  {}
Event Event {
  publication: 8705189047498767,
  topic: 'io.crossbar.demo.pubsub.168223',
  publisher: 7898179471735197,
  publisher_authid: 'E9R5-5Q6T-XRVC-GRNQ-QJL9-RG3Y',
  publisher_authrole: 'anonymous',
  retained: false } received args [ 'Hello, world. QWE' ] kwargs  {}

*/