AUTOBAHN_DEBUG = true;
const autobahn = require('autobahn')
const program = require('commander')

program
  .option('-s, --server <server>', 'Server URI address', 'wss://jeta.host/wamp')
  .parse(process.argv)

console.log('connect to server:', program.server)

let user = 'joe'
let key = 'joe-secret'

// this callback is fired during authentication
function onchallenge (session, method, extra) {
  if (method === 'ticket') {
    return key
  } else {
    throw new Error("don't know how to authenticate using '" + method + "'")
  }
}

var connection = new autobahn.Connection({
  url: program.server,
  realm: 'gekko',
  authmethods: ['ticket', 'wampcra'],
  authid: user,
//  authextra: {extra1:1},
  tlsConfiguration: {},
  onchallenge: onchallenge
})

connection.onopen = function (session) {
console.log('ENTER', 1)

  // Define an event handler
  function onEvent (publishArgs, kwargs, opts) {
    console.log('Event', opts, 'received args', publishArgs, 'kwargs ', kwargs)
  }

  // Subscribe to a topic
  session.subscribe('gekko.#', onEvent, { match: "prefix" }).then(
    function (subscription) {
      console.log('subscription successfull', subscription.topic)
    },
    function (error) {
      console.log('subscription failed', error)
    }
  )

}

connection.onclose = function (reason, details) {
  console.log('disconnected', reason, details)
}

connection.open()
